import { Ability, UsesAbilities } from '../../../serenity/screenplay';
import { Target } from '../ui/target';
import { ElementArrayFinder, ElementFinder, ProtractorBrowser } from 'protractor';
import * as webdriver from 'selenium-webdriver';
export declare class BrowseTheWeb implements Ability {
    private browser;
    /**
     *
     * Instantiates the Ability to BrowseTheWeb, allowing the Actor to interact with a Web UI
     *
     * @param browser
     * @return {BrowseTheWeb}
     */
    static using(browser: ProtractorBrowser): BrowseTheWeb;
    /**
     * Used to access the Actor's ability to BrowseTheWeb from within the Interaction classes, such as Click or Enter
     *
     * @param actor
     * @return {BrowseTheWeb}
     */
    static as(actor: UsesAbilities): BrowseTheWeb;
    locate(target: Target): ElementFinder;
    locateAll(target: Target): ElementArrayFinder;
    takeScreenshot(): PromiseLike<string>;
    get(destination: string, timeout?: number): PromiseLike<void>;
    getTitle(): PromiseLike<string>;
    actions(): webdriver.ActionSequence;
    manage(): webdriver.Options;
    constructor(browser: ProtractorBrowser);
}
