"use strict";
var browse_the_web_1 = require('../abilities/browse_the_web');
var protractor_1 = require('protractor');
var Select = (function () {
    function Select() {
    }
    Select.theValue = function (value) {
        return { from: function (target) { return new SelectOption(value, target); } };
    };
    Select.values = function () {
        var values = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            values[_i - 0] = arguments[_i];
        }
        return { from: function (target) { return new SelectOptions(values, target); } };
    };
    return Select;
}());
exports.Select = Select;
var SelectOption = (function () {
    function SelectOption(value, target) {
        this.value = value;
        this.target = target;
    }
    SelectOption.prototype.performAs = function (actor) {
        return browse_the_web_1.BrowseTheWeb.as(actor)
            .locate(this.target)
            .element(protractor_1.by.cssContainingText('option', this.value))
            .click();
    };
    return SelectOption;
}());
var SelectOptions = (function () {
    function SelectOptions(values, target) {
        this.values = values;
        this.target = target;
    }
    SelectOptions.prototype.performAs = function (actor) {
        var _this = this;
        var hasRequiredText = function (option) { return option.getText().then(function (value) { return !!~_this.values.indexOf(value); }); }, isAlreadySelected = function (option) { return option.isSelected(); }, ensureOnlyOneApplies = function (list) { return list.filter(function (_) { return _ === true; }).length === 1; }, select = function (option) { return option.click(); };
        var optionsToClick = function (option) { return Promise.all([
            hasRequiredText(option),
            isAlreadySelected(option),
        ])
            .then(ensureOnlyOneApplies); };
        return browse_the_web_1.BrowseTheWeb.as(actor).locate(this.target)
            .all(protractor_1.by.css('option'))
            .filter(optionsToClick)
            .each(select);
    };
    return SelectOptions;
}());

//# sourceMappingURL=select.js.map
