import { Performable } from './performables';
import { Question } from './question';
export interface Ability {
}
export declare type CustomAbility<T extends Ability> = {
    new (...args): T;
};
export interface PerformsTasks {
    attemptsTo(...tasks: Performable[]): Promise<void>;
}
export interface UsesAbilities {
    /**
     * Gives the Actor the Abilities to perform Actions
     *
     * @param abilities
     */
    whoCan<T extends UsesAbilities>(...abilities: Ability[]): T;
    /**
     * Grants access to the Actor's ability
     *
     * @param doSomething   Ability class name
     */
    abilityTo<T extends Ability>(doSomething: CustomAbility<T>): T;
}
export interface AnswersQuestions {
    toSee<T>(question: Question<T>): T;
}
export declare class Actor implements PerformsTasks, UsesAbilities, AnswersQuestions {
    private name;
    private abilities;
    static named(name: string): Actor;
    whoCan(...abilities: Ability[]): Actor;
    abilityTo<T extends Ability>(doSomething: CustomAbility<T>): T;
    attemptsTo(...tasks: Performable[]): Promise<void>;
    toSee<T>(question: Question<T>): PromiseLike<T> | T;
    toString(): string;
    constructor(name: string);
    private can<T>(doSomething);
    private nameOf<T>(ability);
}
