"use strict";
var Stage = (function () {
    function Stage(manager) {
        this.manager = manager;
    }
    Stage.prototype.enter = function (cast) {
        this.cast = cast;
        return this;
    };
    Stage.prototype.theActorCalled = function (actorName) {
        if (!this.castIsReady()) {
            throw new Error('The cast has not entered the stage yet.');
        }
        this.actorInTheSpotlight = this.cast.actor(actorName);
        return this.actorInTheSpotlight;
    };
    Stage.prototype.theShowHasStarted = function () {
        return !!this.actorInTheSpotlight;
    };
    Stage.prototype.theActorInTheSpotlight = function () {
        if (!this.theShowHasStarted()) {
            throw new Error('There\'s no actor in the spotlight yet.');
        }
        return this.actorInTheSpotlight;
    };
    Stage.prototype.castIsReady = function () {
        return !!this.cast;
    };
    return Stage;
}());
exports.Stage = Stage;

//# sourceMappingURL=stage.js.map
